diff --git a/usr.sbin/l2ping/l2ping.c b/usr.sbin/l2ping/l2ping.c
new file mode 100644
index 0000000000..0b4ebdb375
--- /dev/null
+++ b/usr.sbin/l2ping/l2ping.c
@@ -0,0 +1,292 @@
+/*
+ * l2ping.c
+ *
+ * Copyright (c) 2001-2002 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: l2ping.c,v 1.5 2003/05/16 19:54:40 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/l2ping/l2ping.c 220116 2011-03-28 23:08:18Z emax $
+ */
+
+#include <sys/ioctl.h>
+#include <sys/time.h>
+#include <arpa/inet.h>
+#include <netinet/in.h>
+#include <assert.h>
+#include <bluetooth.h>
+#include <err.h>
+#include <errno.h>
+#include <limits.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+static void	usage	(void);
+static void	tv_sub	(struct timeval *, struct timeval const *);
+static double	tv2msec	(struct timeval const *);
+
+#undef	min
+#define	min(x, y)	(((x) > (y))? (y) : (x))
+
+static char const		pattern[] = "1234567890-";
+#define PATTERN_SIZE		(sizeof(pattern) - 1)
+
+/* 
+ * Main 
+ */
+
+int
+main(int argc, char *argv[])
+{
+	bdaddr_t		 src, dst;
+	struct hostent		*he;
+	uint8_t			*echo_data;
+	struct sockaddr_l2cap	 sa;
+	int32_t			 n, s, count, wait, flood, echo_size, numeric;
+	char			*endp, *rname;
+
+	/* Set defaults */
+	memcpy(&src, NG_HCI_BDADDR_ANY, sizeof(src));
+	memcpy(&dst, NG_HCI_BDADDR_ANY, sizeof(dst));
+
+	echo_data = (uint8_t *) calloc(NG_L2CAP_MAX_ECHO_SIZE, sizeof(uint8_t));
+	if (echo_data == NULL) {
+		fprintf(stderr, "Failed to allocate echo data buffer");
+		exit(1);
+	}
+
+	/*
+	 * Set default echo size to the NG_L2CAP_MTU_MINIMUM minus
+	 * the size of the L2CAP signalling command header.
+	 */
+
+	echo_size = NG_L2CAP_MTU_MINIMUM - sizeof(ng_l2cap_cmd_hdr_t);
+	count = -1; /* unimited */
+	wait = 1;   /* sec */
+	flood = 0;
+	numeric = 0;
+
+	/* Parse command line arguments */
+	while ((n = getopt(argc, argv, "a:c:fi:nS:s:h")) != -1) {
+		switch (n) {
+		case 'a':
+			if (!bt_aton(optarg, &dst)) {
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+
+				memcpy(&dst, he->h_addr, sizeof(dst));
+			}
+			break;
+
+		case 'c':
+			count = strtol(optarg, &endp, 10);
+			if (count <= 0 || *endp != '\0')
+				usage();
+			break;
+
+		case 'f':
+			flood = 1;
+			break;
+
+		case 'i':
+			wait = strtol(optarg, &endp, 10);
+			if (wait <= 0 || *endp != '\0')
+				usage();
+			break;
+
+		case 'n':
+			numeric = 1;
+			break;
+
+		case 'S':
+			if (!bt_aton(optarg, &src)) {
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+
+				memcpy(&src, he->h_addr, sizeof(src));
+			}
+			break;
+
+		case 's':
+                        echo_size = strtol(optarg, &endp, 10);
+                        if (echo_size < sizeof(int32_t) ||
+			    echo_size > NG_L2CAP_MAX_ECHO_SIZE ||
+			    *endp != '\0')
+				usage();
+			break;
+
+		case 'h':
+		default:
+			usage();
+			break;
+		}
+	}
+
+	if (memcmp(&dst, NG_HCI_BDADDR_ANY, sizeof(dst)) == 0)
+		usage();
+
+	he = bt_gethostbyaddr((const char *)&dst, sizeof(dst), AF_BLUETOOTH);
+	if (he == NULL || he->h_name == NULL || he->h_name[0] == '\0' || numeric)
+		asprintf(&rname, "%s", bt_ntoa(&dst, NULL));
+	else
+		rname = strdup(he->h_name);
+
+	if (rname == NULL)
+		errx(1, "Failed to create remote hostname");
+
+	s = socket(PF_BLUETOOTH, SOCK_RAW, BLUETOOTH_PROTO_L2CAP);
+	if (s < 0)
+		err(2, "Could not create socket");
+
+	memset(&sa, 0, sizeof(sa));
+	sa.l2cap_len = sizeof(sa);
+	sa.l2cap_family = AF_BLUETOOTH;
+	memcpy(&sa.l2cap_bdaddr, &src, sizeof(sa.l2cap_bdaddr));
+
+	if (bind(s, (struct sockaddr *) &sa, sizeof(sa)) < 0)
+		err(3,
+"Could not bind socket, src bdaddr=%s", bt_ntoa(&sa.l2cap_bdaddr, NULL));
+
+	memset(&sa, 0, sizeof(sa));
+	sa.l2cap_len = sizeof(sa);
+	sa.l2cap_family = AF_BLUETOOTH;
+	memcpy(&sa.l2cap_bdaddr, &dst, sizeof(sa.l2cap_bdaddr));
+
+	if (connect(s, (struct sockaddr *) &sa, sizeof(sa)) < 0)
+		err(4,
+"Could not connect socket, dst bdaddr=%s", bt_ntoa(&sa.l2cap_bdaddr, NULL));
+
+	/* Fill pattern */
+	for (n = 0; n < echo_size; ) {
+		int32_t	avail = min(echo_size - n, PATTERN_SIZE);
+
+		memcpy(echo_data + n, pattern, avail);
+		n += avail;
+	}
+
+	/* Start ping'ing */
+	for (n = 0; count == -1 || count > 0; n ++) {
+		struct ng_btsocket_l2cap_raw_ping	r;
+		struct timeval				a, b;
+		int32_t					fail;
+
+		if (gettimeofday(&a, NULL) < 0)
+			err(5, "Could not gettimeofday(a)");
+
+		fail = 0;
+		*((int32_t *) echo_data) = htonl(n);
+
+		r.result = 0;
+		r.echo_size = echo_size;
+		r.echo_data = echo_data;
+		if (ioctl(s, SIOC_L2CAP_L2CA_PING, &r, sizeof(r)) < 0) {
+			r.result = errno;
+			fail = 1;
+/*
+			warn("Could not ping, dst bdaddr=%s",
+				bt_ntoa(&r.echo_dst, NULL));
+*/
+		}
+
+		if (gettimeofday(&b, NULL) < 0)
+			err(7, "Could not gettimeofday(b)");
+
+		tv_sub(&b, &a);
+
+		fprintf(stdout,
+"%d bytes from %s seq_no=%d time=%.3f ms result=%#x %s\n",
+			r.echo_size,
+			rname,
+			ntohl(*((int32_t *)(r.echo_data))),
+			tv2msec(&b), r.result,
+			((fail == 0)? "" : strerror(errno)));
+
+		if (!flood) {
+			/* Wait */
+			a.tv_sec = wait;
+			a.tv_usec = 0;
+			select(0, NULL, NULL, NULL, &a);
+		}
+
+		if (count != -1)
+			count --;
+	}
+
+	free(rname);
+	free(echo_data);
+	close(s);
+
+	return (0);
+} /* main */
+
+/* 
+ * a -= b, for timevals 
+ */
+
+static void
+tv_sub(struct timeval *a, struct timeval const *b)
+{
+	if (a->tv_usec < b->tv_usec) {
+		a->tv_usec += 1000000;
+		a->tv_sec -= 1;
+	}
+
+	a->tv_usec -= b->tv_usec;
+	a->tv_sec -= b->tv_sec;
+} /* tv_sub */
+
+/* 
+ * convert tv to msec 
+ */
+
+static double
+tv2msec(struct timeval const *tvp)
+{
+	return(((double)tvp->tv_usec)/1000.0 + ((double)tvp->tv_sec)*1000.0);
+} /* tv2msec */
+
+/* 
+ * Usage 
+ */
+
+static void
+usage(void)
+{
+	fprintf(stderr, "Usage: l2ping [-fhn] -a remote " \
+		"[-c count] [-i wait] [-S source] [-s size]\n");
+	fprintf(stderr, "Where:\n");
+	fprintf(stderr, "  -a remote  Specify remote device to ping\n");
+	fprintf(stderr, "  -c count   Number of packets to send\n");
+	fprintf(stderr, "  -f         No delay between packets\n");
+	fprintf(stderr, "  -h         Display this message\n");
+	fprintf(stderr, "  -i wait    Delay between packets (sec)\n");
+	fprintf(stderr, "  -n         Numeric output only\n");
+	fprintf(stderr, "  -S source  Specify source device\n");
+	fprintf(stderr, "  -s size    Packet size (bytes), " \
+		"between %zd and %zd\n", sizeof(int32_t), NG_L2CAP_MAX_ECHO_SIZE);
+	
+	exit(255);
+} /* usage */
+
diff --git a/usr.sbin/rfcomm_pppd/Makefile b/usr.sbin/rfcomm_pppd/Makefile
new file mode 100644
index 0000000000..6478d05c65
--- /dev/null
+++ b/usr.sbin/rfcomm_pppd/Makefile
@@ -0,0 +1,14 @@
+# $Id: Makefile,v 1.7 2003/09/07 18:32:11 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/rfcomm_pppd/Makefile 121054 2003-10-12 22:04:24Z emax $
+
+.PATH:	${.CURDIR}/../../usr.bin/rfcomm_sppd
+
+PROG=		rfcomm_pppd
+MAN=		rfcomm_pppd.8
+SRCS=		rfcomm_pppd.c rfcomm_sdp.c
+WARNS?=		2
+
+DPADD=		${LIBBLUETOOTH} ${LIBSDP}
+LDADD=		-lbluetooth -lsdp
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/rfcomm_pppd/rfcomm_pppd.c b/usr.sbin/rfcomm_pppd/rfcomm_pppd.c
new file mode 100644
index 0000000000..fc8756a56f
--- /dev/null
+++ b/usr.sbin/rfcomm_pppd/rfcomm_pppd.c
@@ -0,0 +1,471 @@
+/*
+ * rfcomm_pppd.c
+ */
+
+/*-
+ * Copyright (c) 2001-2008 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: rfcomm_pppd.c,v 1.5 2003/09/07 18:32:11 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/rfcomm_pppd/rfcomm_pppd.c 188130 2009-02-04 22:04:06Z emax $
+ */
+
+#include <bluetooth.h>
+#include <ctype.h>
+#include <err.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <sdp.h>
+#include <signal.h>
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <syslog.h>
+#include <unistd.h>
+
+#define RFCOMM_PPPD	"rfcomm_pppd"
+
+int		rfcomm_channel_lookup	(bdaddr_t const *local,
+					 bdaddr_t const *remote,
+					 int service, int *channel, int *error);
+
+static void	exec_ppp	(int s, char *unit, char *label);
+static void	sighandler	(int s);
+static void	usage		(void);
+
+static int	done;
+
+/* Main */
+int
+main(int argc, char *argv[])
+{
+	struct sockaddr_rfcomm   sock_addr;
+	char			*label = NULL, *unit = NULL, *ep = NULL;
+	bdaddr_t		 addr;
+	int			 s, channel, detach, server, service,
+				 regdun, regsp;
+	pid_t			 pid;
+
+	memcpy(&addr, NG_HCI_BDADDR_ANY, sizeof(addr));
+	channel = 0;
+	detach = 1;
+	server = 0;
+	service = 0;
+	regdun = 0;
+	regsp = 0;
+
+	/* Parse command line arguments */
+	while ((s = getopt(argc, argv, "a:cC:dDhl:sSu:")) != -1) {
+		switch (s) {
+		case 'a': /* BDADDR */
+			if (!bt_aton(optarg, &addr)) {
+				struct hostent	*he = NULL;
+
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+
+				memcpy(&addr, he->h_addr, sizeof(addr));
+			}
+			break;
+
+		case 'c': /* client */
+			server = 0;
+			break;
+
+		case 'C': /* RFCOMM channel */
+			channel = strtoul(optarg, &ep, 10);
+			if (*ep != '\0') {
+				channel = 0;
+				switch (tolower(optarg[0])) {
+				case 'd': /* DialUp Networking */
+					service = SDP_SERVICE_CLASS_DIALUP_NETWORKING;
+					break;
+
+				case 'l': /* LAN Access Using PPP */
+					service = SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP;
+					break;
+				}
+			}
+			break;
+
+		case 'd': /* do not detach */
+			detach = 0;
+			break;
+
+		case 'D': /* Register DUN service as well as LAN service */
+			regdun = 1;
+			break;
+
+		case 'l': /* PPP label */
+			label = optarg;
+			break;
+
+		case 's': /* server */
+			server = 1;
+			break;
+
+		case 'S': /* Register SP service as well as LAN service */
+			regsp = 1;
+			break;
+
+		case 'u': /* PPP -unit option */
+			strtoul(optarg, &ep, 10);
+			if (*ep != '\0')
+				usage();
+				/* NOT REACHED */
+
+			unit = optarg;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	/* Check if we got everything we wanted */
+	if (label == NULL)
+                errx(1, "Must specify PPP label");
+
+	if (!server) {
+		if (memcmp(&addr, NG_HCI_BDADDR_ANY, sizeof(addr)) == 0)
+                	errx(1, "Must specify server BD_ADDR");
+
+		/* Check channel, if was not set then obtain it via SDP */
+		if (channel == 0 && service != 0)
+			if (rfcomm_channel_lookup(NULL, &addr, service,
+							&channel, &s) != 0)
+				errc(1, s, "Could not obtain RFCOMM channel");
+	}
+
+        if (channel <= 0 || channel > 30)
+                errx(1, "Invalid RFCOMM channel number %d", channel);
+
+	openlog(RFCOMM_PPPD, LOG_PID | LOG_PERROR | LOG_NDELAY, LOG_USER);
+
+	if (detach && daemon(0, 0) < 0) {
+		syslog(LOG_ERR, "Could not daemon(0, 0). %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	s = socket(PF_BLUETOOTH, SOCK_STREAM, BLUETOOTH_PROTO_RFCOMM);
+	if (s < 0) {
+		syslog(LOG_ERR, "Could not create socket. %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	if (server) {
+		struct sigaction	 sa;
+		void			*ss = NULL;
+		sdp_lan_profile_t	 lan;
+
+		/* Install signal handler */
+		memset(&sa, 0, sizeof(sa));
+		sa.sa_handler = sighandler;
+
+		if (sigaction(SIGTERM, &sa, NULL) < 0) {
+			syslog(LOG_ERR, "Could not sigaction(SIGTERM). %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		if (sigaction(SIGHUP, &sa, NULL) < 0) {
+			syslog(LOG_ERR, "Could not sigaction(SIGHUP). %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		if (sigaction(SIGINT, &sa, NULL) < 0) {
+			syslog(LOG_ERR, "Could not sigaction(SIGINT). %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		sa.sa_handler = SIG_IGN;
+		sa.sa_flags = SA_NOCLDWAIT;
+
+		if (sigaction(SIGCHLD, &sa, NULL) < 0) {
+			syslog(LOG_ERR, "Could not sigaction(SIGCHLD). %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		/* bind socket and listen for incoming connections */
+		sock_addr.rfcomm_len = sizeof(sock_addr);
+		sock_addr.rfcomm_family = AF_BLUETOOTH;
+		memcpy(&sock_addr.rfcomm_bdaddr, &addr,
+			sizeof(sock_addr.rfcomm_bdaddr));
+		sock_addr.rfcomm_channel = channel;
+
+		if (bind(s, (struct sockaddr *) &sock_addr,
+				sizeof(sock_addr)) < 0) {
+			syslog(LOG_ERR, "Could not bind socket. %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		if (listen(s, 10) < 0) {
+			syslog(LOG_ERR, "Could not listen on socket. %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		ss = sdp_open_local(NULL);
+		if (ss == NULL) {
+			syslog(LOG_ERR, "Unable to create local SDP session");
+			exit(1);
+		}
+
+		if (sdp_error(ss) != 0) {
+			syslog(LOG_ERR, "Unable to open local SDP session. " \
+				"%s (%d)", strerror(sdp_error(ss)),
+				sdp_error(ss));
+			exit(1);
+		}
+
+		memset(&lan, 0, sizeof(lan));
+		lan.server_channel = channel;
+
+		if (sdp_register_service(ss,
+				SDP_SERVICE_CLASS_LAN_ACCESS_USING_PPP,
+				&addr, (void *) &lan, sizeof(lan), NULL) != 0) {
+			syslog(LOG_ERR, "Unable to register LAN service with " \
+				"local SDP daemon. %s (%d)",
+				strerror(sdp_error(ss)), sdp_error(ss));
+			exit(1);
+		}
+
+		/*
+		 * Register DUN (Dial-Up Networking) service on the same
+		 * RFCOMM channel if requested. There is really no good reason
+		 * to not to support this. AT-command exchange can be faked
+		 * with chat script in ppp.conf
+		 */
+
+		if (regdun) {
+			sdp_dun_profile_t	dun;
+
+			memset(&dun, 0, sizeof(dun));
+			dun.server_channel = channel;
+
+			if (sdp_register_service(ss,
+					SDP_SERVICE_CLASS_DIALUP_NETWORKING,
+					&addr, (void *) &dun, sizeof(dun),
+					NULL) != 0) {
+				syslog(LOG_ERR, "Unable to register DUN " \
+					"service with local SDP daemon. " \
+					"%s (%d)", strerror(sdp_error(ss)),
+					sdp_error(ss));
+				exit(1);
+			}
+		}
+
+		/*
+		 * Register SP (Serial Port) service on the same RFCOMM channel
+		 * if requested. It appears that some cell phones are using so
+		 * called "callback mechanism". In this scenario user is trying
+		 * to connect his cell phone to the Internet, and, user's host
+		 * computer is acting as the gateway server. It seems that it
+		 * is not possible to tell the phone to just connect and start
+		 * using the LAN service. Instead the user's host computer must
+		 * "jump start" the phone by connecting to the phone's SP
+		 * service. What happens next is the phone kills the existing
+		 * connection and opens another connection back to the user's
+		 * host computer. The phone really wants to use LAN service,
+		 * but for whatever reason it looks for SP service on the
+		 * user's host computer. This brain damaged behavior was
+		 * reported for Nokia 6600 and Sony/Ericsson P900. Both phones
+		 * are Symbian-based phones. Perhaps this is a Symbian problem?
+		 */
+
+		if (regsp) {
+			sdp_sp_profile_t	sp;
+
+			memset(&sp, 0, sizeof(sp));
+			sp.server_channel = channel;
+
+			if (sdp_register_service(ss,
+					SDP_SERVICE_CLASS_SERIAL_PORT,
+					&addr, (void *) &sp, sizeof(sp),
+					NULL) != 0) {
+				syslog(LOG_ERR, "Unable to register SP " \
+					"service with local SDP daemon. " \
+					"%s (%d)", strerror(sdp_error(ss)),
+					sdp_error(ss));
+				exit(1);
+			}
+		}
+		
+		for (done = 0; !done; ) {
+			socklen_t	len = sizeof(sock_addr);
+			int		s1 = accept(s, (struct sockaddr *) &sock_addr, &len);
+
+			if (s1 < 0) {
+				syslog(LOG_ERR, "Could not accept connection " \
+					"on socket. %s (%d)", strerror(errno),
+					errno);
+				exit(1);
+			}
+				
+			pid = fork();
+			if (pid == (pid_t) -1) {
+				syslog(LOG_ERR, "Could not fork(). %s (%d)",
+					strerror(errno), errno);
+				exit(1);
+			}
+
+			if (pid == 0) {
+				sdp_close(ss);
+				close(s);
+
+				/* Reset signal handler */
+				memset(&sa, 0, sizeof(sa));
+				sa.sa_handler = SIG_DFL;
+
+				sigaction(SIGTERM, &sa, NULL);
+				sigaction(SIGHUP, &sa, NULL);
+				sigaction(SIGINT, &sa, NULL);
+				sigaction(SIGCHLD, &sa, NULL);
+
+				/* Become daemon */
+				daemon(0, 0);
+
+				/*
+				 * XXX Make sure user does not shoot himself
+				 * in the foot. Do not pass unit option to the
+				 * PPP when operating in the server mode.
+				 */
+
+				exec_ppp(s1, NULL, label);
+			} else
+				close(s1);
+		}
+	} else {
+		sock_addr.rfcomm_len = sizeof(sock_addr);
+		sock_addr.rfcomm_family = AF_BLUETOOTH;
+		memcpy(&sock_addr.rfcomm_bdaddr, NG_HCI_BDADDR_ANY,
+			sizeof(sock_addr.rfcomm_bdaddr));
+		sock_addr.rfcomm_channel = 0;
+
+		if (bind(s, (struct sockaddr *) &sock_addr,
+				sizeof(sock_addr)) < 0) {
+			syslog(LOG_ERR, "Could not bind socket. %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		memcpy(&sock_addr.rfcomm_bdaddr, &addr,
+			sizeof(sock_addr.rfcomm_bdaddr));
+		sock_addr.rfcomm_channel = channel;
+
+		if (connect(s, (struct sockaddr *) &sock_addr,
+				sizeof(sock_addr)) < 0) {
+			syslog(LOG_ERR, "Could not connect socket. %s (%d)",
+				strerror(errno), errno);
+			exit(1);
+		}
+
+		exec_ppp(s, unit, label);
+	}
+
+	exit(0);
+} /* main */
+
+/* 
+ * Redirects stdin/stdout to s, stderr to /dev/null and exec
+ * 'ppp -direct -quiet [-unit N] label'. Never returns.
+ */
+
+static void
+exec_ppp(int s, char *unit, char *label)
+{
+	char	 ppp[] = "/usr/sbin/ppp";
+	char	*ppp_args[] = { ppp,  "-direct", "-quiet",
+				NULL, NULL,      NULL,     NULL };
+
+	close(0);
+	if (dup(s) < 0) {
+		syslog(LOG_ERR, "Could not dup(0). %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	close(1);
+	if (dup(s) < 0) {
+		syslog(LOG_ERR, "Could not dup(1). %s (%d)",
+			strerror(errno), errno);
+		exit(1);
+	}
+
+	close(2);
+	open("/dev/null", O_RDWR);
+
+	if (unit != NULL) {
+		ppp_args[3] = "-unit";
+		ppp_args[4] = unit;
+		ppp_args[5] = label;
+	} else
+		ppp_args[3] = label;
+
+	if (execv(ppp, ppp_args) < 0) {
+		syslog(LOG_ERR, "Could not exec(%s -direct -quiet%s%s %s). " \
+			"%s (%d)", ppp, (unit != NULL)? " -unit " : "",
+			(unit != NULL)? unit : "", label,
+			strerror(errno), errno);
+		exit(1);
+	}
+} /* run_ppp */
+
+/* Signal handler */
+static void
+sighandler(int s)
+{
+	done = 1;
+} /* sighandler */
+
+/* Display usage and exit */
+static void
+usage(void)
+{
+	fprintf(stdout,
+"Usage: %s options\n" \
+"Where options are:\n" \
+"\t-a address   Address to listen on or connect to (required for client)\n" \
+"\t-c           Act as a clinet (default)\n" \
+"\t-C channel   RFCOMM channel to listen on or connect to (required)\n" \
+"\t-d           Run in foreground\n" \
+"\t-D           Register Dial-Up Networking service (server mode only)\n" \
+"\t-l label     Use PPP label (required)\n" \
+"\t-s           Act as a server\n" \
+"\t-S           Register Serial Port service (server mode only)\n" \
+"\t-u N         Tell PPP to operate on /dev/tunN (client mode only)\n" \
+"\t-h           Display this message\n", RFCOMM_PPPD);
+
+	exit(255);
+} /* usage */
+
diff --git a/usr.sbin/sdpcontrol/Makefile b/usr.sbin/sdpcontrol/Makefile
new file mode 100644
index 0000000000..60a54ff90b
--- /dev/null
+++ b/usr.sbin/sdpcontrol/Makefile
@@ -0,0 +1,12 @@
+# $Id: Makefile,v 1.1 2003/09/08 02:27:27 max Exp $
+# $FreeBSD: head/usr.sbin/bluetooth/sdpcontrol/Makefile 121054 2003-10-12 22:04:24Z emax $
+
+PROG=		sdpcontrol
+MAN=		sdpcontrol.8
+SRCS=		sdpcontrol.c search.c
+WARNS?=		2
+
+DPADD=		${LIBBLUETOOTH} ${LIBSDP}
+LDADD=		-lbluetooth -lsdp
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/sdpcontrol/sdpcontrol.c b/usr.sbin/sdpcontrol/sdpcontrol.c
new file mode 100644
index 0000000000..f240313e07
--- /dev/null
+++ b/usr.sbin/sdpcontrol/sdpcontrol.c
@@ -0,0 +1,219 @@
+/*
+ * sdpcontrol.c
+ *
+ * Copyright (c) 2001-2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: sdpcontrol.c,v 1.1 2003/09/08 02:27:27 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpcontrol/sdpcontrol.c 133178 2004-08-05 16:32:41Z emax $
+ */
+
+#include <assert.h>
+#include <bluetooth.h>
+#include <err.h>
+#include <errno.h>
+#include <sdp.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include "sdpcontrol.h"
+
+/* Prototypes */
+static int                  do_sdp_command	(bdaddr_p, char const *, int,
+						 int, char **);
+static struct sdp_command * find_sdp_command	(char const *,
+						 struct sdp_command *); 
+static void                 print_sdp_command	(struct sdp_command *);
+static void                 usage		(void);
+
+/* Main */
+int
+main(int argc, char *argv[])
+{
+	char const	*control = SDP_LOCAL_PATH;
+	int		 n, local;
+	bdaddr_t	 bdaddr;
+
+	memset(&bdaddr, 0, sizeof(bdaddr));
+	local = 0;
+
+	/* Process command line arguments */
+	while ((n = getopt(argc, argv, "a:c:lh")) != -1) {
+		switch (n) {
+		case 'a': /* bdaddr */
+			if (!bt_aton(optarg, &bdaddr)) {
+				struct hostent  *he = NULL;
+
+				if ((he = bt_gethostbyname(optarg)) == NULL)
+					errx(1, "%s: %s", optarg, hstrerror(h_errno));
+ 
+				memcpy(&bdaddr, he->h_addr, sizeof(bdaddr));
+			}
+			break;
+
+		case 'c': /* control socket */
+			control = optarg;
+			break;
+
+		case 'l': /* local sdpd */
+			local = 1;
+			break;
+
+		case 'h':
+		default:
+			usage();
+			/* NOT REACHED */
+		}
+	}
+
+	argc -= optind; 
+	argv += optind;
+
+	if (*argv == NULL)
+		usage();
+
+	return (do_sdp_command(&bdaddr, control, local, argc, argv));
+}
+
+/* Execute commands */
+static int
+do_sdp_command(bdaddr_p bdaddr, char const *control, int local,
+		int argc, char **argv)
+{
+	char			*cmd = argv[0];
+	struct sdp_command	*c = NULL;
+	void			*xs = NULL;
+	int			 e, help;
+
+	help = 0;
+	if (strcasecmp(cmd, "help") == 0) {
+		argc --;
+		argv ++;
+
+		if (argc <= 0) {
+			fprintf(stdout, "Supported commands:\n");
+			print_sdp_command(sdp_commands);
+			fprintf(stdout, "\nFor more information use " \
+				"'help command'\n");
+
+			return (OK);
+		}
+
+		help = 1;
+		cmd = argv[0];
+	}
+
+	c = find_sdp_command(cmd, sdp_commands);
+	if (c == NULL) {
+		fprintf(stdout, "Unknown command: \"%s\"\n", cmd);
+		return (ERROR);
+	}
+
+	if (!help) {
+		if (!local) {
+			if (memcmp(bdaddr, NG_HCI_BDADDR_ANY, sizeof(*bdaddr)) == 0)
+				usage();
+
+			xs = sdp_open(NG_HCI_BDADDR_ANY, bdaddr);
+		} else
+			xs = sdp_open_local(control);
+
+		if (xs == NULL)
+			errx(1, "Could not create SDP session object");
+		if (sdp_error(xs) == 0)
+			e = (c->handler)(xs, -- argc, ++ argv);
+		else
+			e = ERROR;
+	} else
+		e = USAGE;
+
+	switch (e) {
+	case OK:
+	case FAILED:
+		break;
+
+	case ERROR:
+		fprintf(stdout, "Could not execute command \"%s\". %s\n",
+			cmd, strerror(sdp_error(xs)));
+		break;
+
+	case USAGE:
+		fprintf(stdout, "Usage: %s\n%s\n", c->command, c->description);
+		break;
+
+	default: assert(0); break;
+	}
+
+	sdp_close(xs);
+
+	return (e);
+} /* do_sdp_command */
+
+/* Try to find command in specified category */
+static struct sdp_command *
+find_sdp_command(char const *command, struct sdp_command *category)   
+{
+	struct sdp_command	*c = NULL;
+
+	for (c = category; c->command != NULL; c++) {
+		char	*c_end = strchr(c->command, ' ');
+
+		if (c_end != NULL) {
+			int	len = c_end - c->command;
+
+			if (strncasecmp(command, c->command, len) == 0)
+				return (c);
+		} else if (strcasecmp(command, c->command) == 0)
+				return (c);
+	}
+
+	return (NULL);
+} /* find_sdp_command */
+
+/* Print commands in specified category */
+static void
+print_sdp_command(struct sdp_command *category)
+{
+	struct sdp_command	*c = NULL;
+
+	for (c = category; c->command != NULL; c++)
+		fprintf(stdout, "\t%s\n", c->command);
+} /* print_sdp_command */
+
+/* Usage */
+static void
+usage(void)
+{
+	fprintf(stderr,
+"Usage: sdpcontrol options command\n" \
+"Where options are:\n"
+"	-a address	address to connect to\n" \
+"	-c path		path to the control socket (default is %s)\n" \
+"	-h		display usage and quit\n" \
+"	-l		connect to the local SDP server via control socket\n" \
+"	command		one of the supported commands\n", SDP_LOCAL_PATH);
+	exit(255);
+} /* usage */
+
diff --git a/usr.sbin/sdpcontrol/sdpcontrol.h b/usr.sbin/sdpcontrol/sdpcontrol.h
new file mode 100644
index 0000000000..a4267fd698
--- /dev/null
+++ b/usr.sbin/sdpcontrol/sdpcontrol.h
@@ -0,0 +1,49 @@
+/*
+ * sdpcontrol.h
+ *
+ * Copyright (c) 2001-2003 Maksim Yevmenkin <m_evmenkin@yahoo.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $Id: sdpcontrol.h,v 1.1 2003/09/08 02:27:27 max Exp $
+ * $FreeBSD: head/usr.sbin/bluetooth/sdpcontrol/sdpcontrol.h 121054 2003-10-12 22:04:24Z emax $
+ */
+
+#ifndef __SDPCONTROL_H__
+#define __SDPCONTROL_H__
+
+#define OK			0	/* everything was OK */
+#define ERROR			1	/* could not execute command */
+#define FAILED			2	/* error was reported */
+#define USAGE			3	/* invalid parameters */
+
+struct sdp_command {
+	char const		*command;
+	char const		*description;
+	int			(*handler)(void *, int, char **);
+};
+
+extern struct sdp_command	sdp_commands[];
+
+#endif /* __SDPCONTROL_H__ */
+
